#ifndef errorsH
#define errorsH

#include "typedefs.h"

typedef struct
{
	int err_no;
	char *errmsg;
} err_struct;

extern err_struct errors[];

#define HAS_SYS_ERRNO	(0x40 << 8)
#define HAS_WSA_ERRNO	(0x20 << 8)
#define SERIAL_ERR 		(1 << 8)
#define CMD_ERR 			(2 << 8)
#define USB_ERR			(3 << 8)
#define ETH_ERR			(4 << 8)

#define SER_ERR_TOUT					   SERIAL_ERR + 1 + HAS_SYS_ERRNO
#define SER_ERR_TOUT_NOT_OPEN		   SERIAL_ERR + 2
#define SER_ERR_CONFIG				   SERIAL_ERR + 3 + HAS_SYS_ERRNO
#define SER_ERR_CONFIG_NOT_OPEN	   SERIAL_ERR + 4
#define SER_ERR_COMSTATE			   SERIAL_ERR + 5 + HAS_SYS_ERRNO
#define SER_ERR_ALREADY_OPEN		   SERIAL_ERR + 6
#define SER_ERR_CANT_OPEN			   SERIAL_ERR + 7 + HAS_SYS_ERRNO
#define SER_ERR_OPEN_NO_CHAR_DEV	   SERIAL_ERR + 8
#define SER_ERR_CLOSE_NOT_OPEN	   SERIAL_ERR + 9
#define SER_ERR_CANT_CLOSE			   SERIAL_ERR + 10
#define SER_ERR_TX_NOT_OPEN         SERIAL_ERR + 11
#define SER_ERR_TX					   SERIAL_ERR + 12 + HAS_SYS_ERRNO
#define SER_ERR_TX_SIZE				   SERIAL_ERR + 13
#define SER_ERR_TX_TIMEOUT		SERIAL_ERR + 14
#define SER_ERR_RX_NOT_OPEN		   SERIAL_ERR + 15
#define SER_ERR_NOT_SERIAL				SERIAL_ERR + 16
#define SER_ERR_RX					   SERIAL_ERR + 17 + HAS_SYS_ERRNO
#define SER_ERR_RX_NO_DATA			   SERIAL_ERR + 18
#define SER_INVALID_NAME				SERIAL_ERR + 19

// do nothing here
#define Error_SetErr(x)					false

#endif
